/* ceci est un jeu de sokoban programmer par smashmaster
 2011 */


#include <stdlib.h>
#include <conio.h>
#include "casio31.c"
#include "ascii.h"
#include "main.h"
#include "level.h"

#include "fonx.cpp"
#include "draw14b.c"

#include "Stexte.h"

int q;
int vitesse = 4;

void main()
{
	int get_a_key;
	char skin_mur = 0;
	char skin_fond = 0;
	unsigned char level;
	setpage(0);
	modevideo(1);
	presentation();
	do{
		level = 0;
		get_a_key = 0;
		S_print(10,20,"(1) NOUVELLE PARTIE");
		S_print(10,26,"(2)       AIDE");
		S_print(10,32,"(3)     REGLAGE");
		S_print(10,38,"(4)     QUITTER");
		refresh();
		do{
			if(getkey() == K_1){ get_a_key = 1;}
			if(getkey() == K_2){ get_a_key = 2;}
			if(getkey() == K_3){ get_a_key = 3;}
			if(getkey() == K_4){ get_a_key = 4;}
		}while(! get_a_key);
		clearpage(0);
		if(get_a_key == 3){option( &skin_mur, &skin_fond );}
		if(get_a_key == 2){aide();}
		if(get_a_key == 1){game(level,skin_fond);}
	}while ( get_a_key != 4); //quitter
	clearbuff();
	modevideo(0);
	clearpage(0);
}




void presentation() //affiche ecran de presentation
{
	int psed;   //Position Sprite (axe des abscisse) Ecran de Demarrage
	for(psed =127; psed>12 ;psed=psed-2){ //le sprite se deplace du droite vers la gauche
		clearbuff();               //efface l'ecran
		drawspr(psed,5,autre[0],MODE_MASK_CLIP);  //affiche sprite n0 (ecran de presentation "sokoban mystery" )
		refresh();
	}
	waitakey(K_EXE);
	for(psed =13; psed>-120 ;psed=psed-2){ //aprs que l'utilisateur a appuyer sur la touche [EXE] le sprite sort de l'cran par la gauche
		clearbuff();               //efface l'ecran
		drawspr(psed,5,autre[0],MODE_MASK_CLIP);  //affiche sprite n0 (ecran de presentation "sokoban mystery" )
		refresh();
	}
	clearbuff();
}


void game(unsigned char level, char skin)
{
	q = 0;
	int i,j,pos_x,pos_y,gagner,touche_appuyer; //le perso se trouve au coord pos_x, pos_y
	do
	{
		////// level_debut contient lvl de depart
		for (i=0;i<18;i++)
		{
			for(j=0;j<9;j++)
			{
				levels[0][j][i]=level_debut[level][j][i];
			}
		}
		///////
		touche_appuyer = 0;
		gagner = 0;
		affiche_lvl(&pos_x, &pos_y, level);     // affiche map
		do
		{
			modevideo(1);
			touche_appuyer = 0;
			touche_appuyer = getkey();
			if (touche_appuyer == K_BAS)
			{
				levels[0][pos_y][pos_x] = -1;
				if(levels[0][pos_y+1][pos_x] == -1 || (levels[0][pos_y+1][pos_x] > 63 && levels[0][pos_y+1][pos_x] < 68)){pos_y++;}
				else if(levels[0][pos_y+1][pos_x] > 67 && levels[0][pos_y+1][pos_x] < 73 && ( levels[0][pos_y+2][pos_x] == -1 || ( levels[0][pos_y+2][pos_x] <68 && levels[0][pos_y+2][pos_x] > 63 )))
				{
					pos_y ++;
					levels[0][pos_y][pos_x] = -1;
					if (levels[0][pos_y+1][pos_x] > 63 && levels[0][pos_y+1][pos_x] < 68) {levels[0][pos_y+1][pos_x] = 69; }
					else {levels[0][pos_y+1][pos_x] = 68; }
				}
				levels[0][pos_y][pos_x] = BAS;
			}
			if (touche_appuyer == K_HAUT)
			{
				levels[0][pos_y][pos_x] = -1;
				if(levels[0][pos_y-1][pos_x] == -1 || (levels[0][pos_y-1][pos_x] > 63 && levels[0][pos_y-1][pos_x] < 68)){pos_y--;}
				else if(levels[0][pos_y-1][pos_x] > 67 && levels[0][pos_y-1][pos_x] < 73 && ( levels[0][pos_y-2][pos_x] == -1 || ( levels[0][pos_y-2][pos_x] <68 && levels[0][pos_y-2][pos_x] > 63 )))
				{
					pos_y --;
					levels[0][pos_y][pos_x] = -1;
					if (levels[0][pos_y-1][pos_x] > 63 && levels[0][pos_y-1][pos_x] < 68) {levels[0][pos_y-1][pos_x] = 69; }
					else {levels[0][pos_y-1][pos_x] = 68; }
				}
				levels[0][pos_y][pos_x] = HAUT;
			}
			if (touche_appuyer == K_GAUCHE)
			{
				levels[0][pos_y][pos_x]=-1;
				if(levels[0][pos_y][pos_x-1] == -1 || (levels[0][pos_y][pos_x-1] > 63 && levels[0][pos_y][pos_x-1] < 68)){pos_x--;}
				else if(levels[0][pos_y][pos_x-1] > 67 && levels[0][pos_y][pos_x-1] < 73 && ( levels[0][pos_y][pos_x-2] == -1 || ( levels[0][pos_y][pos_x-2] <68 && levels[0][pos_y][pos_x-2] > 63 )))
				{
					pos_x --;
					levels[0][pos_y][pos_x] = -1;
					if (levels[0][pos_y][pos_x-1] > 63 && levels[0][pos_y][pos_x-1] < 68) {levels[0][pos_y][pos_x-1] = 69; }
					else {levels[0][pos_y][pos_x-1] = 68; }
				}
				levels[0][pos_y][pos_x] = GAUCHE;
			}
			if (touche_appuyer == K_DROITE)
			{
				levels[0][pos_y][pos_x] = -1;
				if(levels[0][pos_y][pos_x+1] == -1 || (levels[0][pos_y][pos_x+1] > 63 && levels[0][pos_y][pos_x+1] < 68)){pos_x++;}
				else if(levels[0][pos_y][pos_x+1] > 67 && levels[0][pos_y][pos_x+1] < 73 && ( levels[0][pos_y][pos_x+2] == -1 || ( levels[0][pos_y][pos_x+2] <68 && levels[0][pos_y][pos_x+2] > 63 )))
				{
					pos_x ++;
					levels[0][pos_y][pos_x] = -1;
					if (levels[0][pos_y][pos_x+1] > 63 && levels[0][pos_y][pos_x+1] < 68) {levels[0][pos_y][pos_x+1] = 69; }
					else {levels[0][pos_y][pos_x+1] = 68; }
				}
				levels[0][pos_y][pos_x] = DROITE;
			}
			if (skin == 2){wait (10);}
			gagner = affiche_lvl(&pos_x, &pos_y, level);     // affiche map, gagner =1 si gagner et gagner =0 si pas encore gagner
		}while ( ! gagner && touche_appuyer != K_ESC && touche_appuyer != K_F1);
		if(gagner)
		{
			level++;
		}
	}while ( touche_appuyer != K_ESC && level != LEVEL_MAX);     //si l'utilisateur veut quitter le jeu
	clearbuff();
}



void aide()
{
	modevideo(0);
	print3(1,1,"I. LES COMMANDES");
	print3(5,8,"(REPLAY) DEPLACER PERSONNAGE");
	print3(5,14,"(F1) RECOMMENCER NIVEAU");
	print3(5,20,"(EXIT) QUITTER LE JEU");
	print3(1,58,"(EXE) POUR CONTINUER");
	do{
	}while( getkey() != K_EXE);
	clearpage(0);
	print3(1,1,"II. REMERCIEMENT");
	print3(1,8,"JE REMERCIE PARTICULIEREMENT :");
	print3(1,14,"- LES CREATEURS DES LIBRAIRIES");
	print3(5,20,"DRAWLIB, CASIO31 ET ASCII");
	print3(1,26,"- SIAPRAN QUI M A AIDER AU");
	print3(5,32,"NIVEAU DES GRAPHISMES DU JEU");
	print3(1,58,"(EXE) POUR CONTINUER");
	do{
	}while( getkey() != K_EXE);
	clearpage(0);
	modevideo(1);
}
/* la fonction qui suit affiche le lvl, elle renvoit
aussi les coord du personnages*/

int affiche_lvl(int *coord_x, int *coord_y, unsigned char level)
{
	clearbuff();
	int x,y,a,b,gagner;
	gagner = 1;
	q++;
	for(x=0;x<18;x++)
	{
		for(y=0;y<9;y++)
		{
			a = levels[0][y][x];
			b = level_debut[level][y][x];
			//debug qque truc////////////////////////////////////////////////////////////////////////////////
			if (a>68 && a<73 && b == -1)
				{levels[0][y][x] = 68;}  // si une caisse ne se trouve plus sur 1 sp_1~4
			if (a == -1 && b > 63 && b<73 && b != 68)
				{levels[0][y][x] = 64;}  //test si une sp_i~4 n'est pas disparue (ce qui peut arriv losqu'un perso passe par dessus)/////////////////
			///////////////////////////////////////////////////////////////


			//actualise map ////////////////////////////////////////////
			a = levels[0][y][x] ;
			if (a != -1 && a != -2){drawspr(7*x+1,7*y+1,sprite[a],MODE_MASK_CLIP);}
			if (q == vitesse)
			{
				if(a>63 && a<68)  //annimation du machin "sp_1~4" (sprite)
				{
					a++;
					levels[0][y][x]=a;
					if(a == 68){levels[0][y][x]=64;}
				}
				if(a>68 && a<73)  //annimation caisse (sprite)
				{
					a++;
					levels[0][y][x]=a;
					if(a == 73){levels[0][y][x]=69;
						a = 69;
					}
				}
				if((a>72 && a<80) || (a>79 && a<87))  //annime le fond
				{
					a++;
					levels[0][y][x]=a;
					if(a == 80){levels[0][y][x]=73;}
					if(a == 87){levels[0][y][x]=80;}
				}
			}
			if(a>59 && a<64)   //stocke coord personnage ds coord_x,coord_y
			{
				*coord_x = x;
				*coord_y = y;
			}
			////////////////////////////////////////

			//test si gagner //////////////////////
			a = levels[0][y][x];
			if ((b == 64 || b == 69) && !(a > 68 && a < 73))
				{gagner = 0;}
			////////////////////////////////////////
		}
	}
	if (q == vitesse){q=0;}
	refresh();
	return gagner ;
}
void option(char *skin_mur, char *skin_fond)
{
	char skin2,a,b,c;
	char skin_visual[1][7][7]={0};
	int getAkey,getKey;
	int touche = 0;
	do
	{
	do{
	}while(getkey());
	getAkey=0;
	clearbuff();
	S_print(1,23,"(1)     VITESSE      ");
	S_print(1,29,"(2)  SKIN DES MURS   ");
	S_print(1,35,"(3)  SKIN DU FOND    ");
	refresh();
	do{
		if(getkey() == K_1){ getAkey = 1;}
		if(getkey() == K_2){ getAkey = 2;}
		if(getkey() == K_3){ getAkey = 3;}
		if(getkey() == K_ESC){getAkey= 4;}
	}while(! getAkey);
	clearbuff();
	/////////////
	if (getAkey == 1) //algorithme pr regler la vitesse
	{
		vitesse = 21-vitesse;
		do
		{
			drawspr(13,20,autre[3],MODE_MASK_CLIP);
			S_print(1,1,"       VITESSE      ");
			S_print(1,36,"  MIN");
			S_print(1,36,"                MAX");
			if (vitesse != 0){
				for (a =0; a < vitesse; a++){drawspr(14+5*a,21,autre[4],MODE_MASK_CLIP);}
				drawspr(4,24,autre[1],MODE_MASK_CLIP);
			}
			if(vitesse != 20){drawspr(120,24,autre[2],MODE_MASK_CLIP);}
			refresh();
			touche = 0;
			do{
				if(getkey() == K_GAUCHE && vitesse != 0){ touche = 1;}
				if(getkey() == K_DROITE && vitesse != 20){ touche = 2;}
				if(getkey() == K_EXE   ){ touche = 3;}
			}while(! touche);
			if (touche == 1){vitesse--;}
			if (touche == 2){vitesse++;}
			clearbuff();
		}while (touche !=3);
		vitesse = 21-vitesse;
	}
	if(getAkey == 2 || getAkey == 3)
	{
		do{

			////////////////////apercu des levels
			for (a=1;a<8;a++)
			{
				for (b=2;b<9;b++){skin_visual[0][a-1][b-2] = level_debut[0][a][b];}
			}
			////////////////////////////////
			if(getAkey == 2){skin2 = *skin_mur;}
			else{skin2 = *skin_fond;}
			clearbuff();
			//affiche map pr voir les skins
			for(a = 0;a <7;a++)
			{
				for(b=0;b<7;b++)
				{
					if(skin_visual[0][a][b] >-1){drawspr(39+7*b,7+7*a,sprite[skin_visual[0][a][b]],MODE_MASK_CLIP);}
				}
			}
			////////////////////////////////
			if (skin2){drawspr(33,29,autre[1],MODE_MASK_CLIP);}
			if ((*skin_mur != 4 && getAkey == 2)||(*skin_fond != 2 && getAkey == 3)){drawspr(90,29,autre[2],MODE_MASK_CLIP);}
			if (getAkey == 2)
			{
				if (*skin_mur == 0){S_print(1,58,"CHATEAU (PAR SIAPRAN)");}
				if (*skin_mur == 1){S_print(1,58,"CHATEAU2");}
				if (*skin_mur == 2){S_print(1,58,"MURS STANDARD");}
				if (*skin_mur == 3){S_print(1,58,"MURS A BRIQUES");}
				if (*skin_mur == 4){S_print(1,58,"COUR");}

			}
			if (getAkey == 3)
			{
				if (*skin_fond == 0){S_print(1,58,"PSY");}
				if (*skin_fond == 1){S_print(1,58,"ESPACE");}
				if (*skin_fond == 2){S_print(1,58,"PAS DE FOND");}

			}
			refresh();
			getKey = 0;
			do{
				if(getkey()== K_GAUCHE){getKey = 1;}
				if(getkey()== K_DROITE){getKey = 2;}
				if(getkey()== K_EXE   ){getKey = 3;}

			}while( !getKey);
			if(getKey == 1 && getAkey == 2 && *skin_mur != 0){(*skin_mur)--;}
			if(getKey == 2 && getAkey == 2 && *skin_mur != 4){(*skin_mur)++;}
			if(getKey == 1 && getAkey == 3 && *skin_fond != 0){(*skin_fond)--;}
			if(getKey == 2 && getAkey == 3 && *skin_fond != 2){(*skin_fond)++;}
			///on modifie skin des levels
			for (c=0;c<LEVEL_MAX;c++)
			{
				for (a=0;a<9;a++)
				{
					for (b=0;b<18;b++)
					{
						if( level_debut[c][a][b] > -1 && level_debut[c][a][b] < 60 && getAkey == 2){ level_debut[c][a][b] = 12*((*skin_mur) - skin2) + level_debut[c][a][b];}
						if( level_debut[c][a][b] > 72 && getAkey == 3)
						{
							if (*skin_fond !=2){level_debut[c][a][b] = 7*((*skin_fond) - skin2) + level_debut[c][a][b];}
							else{level_debut[c][a][b] = -2;}
						}
						if( level_debut[c][a][b] == -2 && *skin_fond != 2 ){ level_debut[c][a][b] = 80;}
					}
				}
			}
			/////////////////////////////////
		}while (getKey != 3 );
		clearbuff();
	}
	}while(getAkey != 4);
	///////////////
}
